/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 20:25:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

/**
 * A database instance backup run resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BackupRun extends com.google.api.client.json.GenericJson {

  /**
   * Backup Configuration identifier.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String backupConfiguration;

  /**
   * The due time of this run in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime dueTime;

  /**
   * The time the backup operation completed in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime endTime;

  /**
   * The time the run was enqueued in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime enqueuedTime;

  /**
   * Information about why the backup operation failed. This is only present if the run has the
   * FAILED status.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OperationError error;

  /**
   * Name of the database instance.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String instance;

  /**
   * This is always sql#backupRun.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The time the backup operation actually started in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime startTime;

  /**
   * The status of this run.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Backup Configuration identifier.
   * @return value or {@code null} for none
   */
  public java.lang.String getBackupConfiguration() {
    return backupConfiguration;
  }

  /**
   * Backup Configuration identifier.
   * @param backupConfiguration backupConfiguration or {@code null} for none
   */
  public BackupRun setBackupConfiguration(java.lang.String backupConfiguration) {
    this.backupConfiguration = backupConfiguration;
    return this;
  }

  /**
   * The due time of this run in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getDueTime() {
    return dueTime;
  }

  /**
   * The due time of this run in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param dueTime dueTime or {@code null} for none
   */
  public BackupRun setDueTime(com.google.api.client.util.DateTime dueTime) {
    this.dueTime = dueTime;
    return this;
  }

  /**
   * The time the backup operation completed in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getEndTime() {
    return endTime;
  }

  /**
   * The time the backup operation completed in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param endTime endTime or {@code null} for none
   */
  public BackupRun setEndTime(com.google.api.client.util.DateTime endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * The time the run was enqueued in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getEnqueuedTime() {
    return enqueuedTime;
  }

  /**
   * The time the run was enqueued in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param enqueuedTime enqueuedTime or {@code null} for none
   */
  public BackupRun setEnqueuedTime(com.google.api.client.util.DateTime enqueuedTime) {
    this.enqueuedTime = enqueuedTime;
    return this;
  }

  /**
   * Information about why the backup operation failed. This is only present if the run has the
   * FAILED status.
   * @return value or {@code null} for none
   */
  public OperationError getError() {
    return error;
  }

  /**
   * Information about why the backup operation failed. This is only present if the run has the
   * FAILED status.
   * @param error error or {@code null} for none
   */
  public BackupRun setError(OperationError error) {
    this.error = error;
    return this;
  }

  /**
   * Name of the database instance.
   * @return value or {@code null} for none
   */
  public java.lang.String getInstance() {
    return instance;
  }

  /**
   * Name of the database instance.
   * @param instance instance or {@code null} for none
   */
  public BackupRun setInstance(java.lang.String instance) {
    this.instance = instance;
    return this;
  }

  /**
   * This is always sql#backupRun.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * This is always sql#backupRun.
   * @param kind kind or {@code null} for none
   */
  public BackupRun setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The time the backup operation actually started in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getStartTime() {
    return startTime;
  }

  /**
   * The time the backup operation actually started in UTC timezone in RFC 3339 format, for example
   * 2012-11-15T16:19:00.094Z.
   * @param startTime startTime or {@code null} for none
   */
  public BackupRun setStartTime(com.google.api.client.util.DateTime startTime) {
    this.startTime = startTime;
    return this;
  }

  /**
   * The status of this run.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * The status of this run.
   * @param status status or {@code null} for none
   */
  public BackupRun setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  @Override
  public BackupRun set(String fieldName, Object value) {
    return (BackupRun) super.set(fieldName, value);
  }

  @Override
  public BackupRun clone() {
    return (BackupRun) super.clone();
  }

}
